#include "stdafx.h"
#include <stdio.h>
#include <mmsystem.h>
#include <winbase.h>
#include "WinModFileTypes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MY_TIMER_ID						0xFABD
#define SetSamplePos(variable,value)	{variable->SamplePos=value;variable->InstrHit=true;}

bool			PlayerReady,PatternBreak,PatternPosJump, 
				PlayerFastForward, PlayerRewind, TimerSet=false, LoopPosSet;
unsigned long	ActualSegment, PlayerMilliSec;
unsigned long	PatternNextRow, PatternNextPos, LoopPatternNextPos, LoopPatternNextRow;
unsigned long	dwStopNextTime, BufferDataLen;
signed long		LoopCount;
unsigned long	BPMSpeed, SamplesPerTick, BPMCounter, BufferFaktor;
unsigned short  Tempo, TempoCount;
unsigned long	PlayerActRow, ActMaxRows, PlayerActPattern, PlayerActPatternIndex;
bool			PlayerUseLinearFrequency;

signed long		*WideStereoTabL=NULL, *WideStereoTabR=NULL, OldSampleL, OldSampleR;
unsigned int	WideStereoWriteIndex, WideStereoReadIndex, MAXWideStereo, mmTimer_ID;
unsigned int	PlayerActTicks;
unsigned char	pDelay;

signed short		*StereoTabL=NULL, *StereoTabR=NULL;
struct PatternData	*ActualPlace=NULL;
struct PatternData	***RowIndex=NULL;
HWND ActhWnd;

void SetVolume(struct voicememory *voice, signed long volume)
{
	if (volume<0) volume=0;
	else
	if (volume>MaxVolValue) volume=MaxVolValue;

	if (voice->PlayerMute)
	{
		voice->ActVolumeL=0; voice->ActVolumeR=0;
	}
	else
	{
		voice->ActVolumeL=(volume*voice->PanningValueL)>>LMUTLISHIFT; 
		voice->ActVolumeR=(volume*voice->PanningValueR)>>LMUTLISHIFT;
	}
}

#define getFinetunePeriod(period,finetune) 	((BASEFreq*(period))/(finetune))
void setPlayerTuning(struct voicememory *voice, unsigned long period)
{
	if (period) voice->PlayerTuning=ThisMod->GlobalTuning/period; // Sicherheitsabfragen mssen nunmal sein!
}

void DoTickEffekts(struct voicememory *voice)
{
	if (voice->VolSlideOn) 
	{
		SetVolume(voice, voice->ActVolume+=voice->VolSlide);
		if (voice->VolumeDoItFine) voice->VolSlideOn=false;
	}
	if (voice->Porta.PortaOn)
	{
		signed long Note = voice->Porta.ActNote+=voice->Porta.Step;
		
		if (voice->Glissando) Note=RoundTon(Note>>4)<<4;
		if (Note>voice->Porta.EndNote && voice->Porta.Step>0 ||
			Note<voice->Porta.EndNote && voice->Porta.Step<0)
		{
			Note=voice->Porta.ActNote=voice->Porta.EndNote;
			voice->Porta.EndNote=0; // Wieder lschen, da neugesetzt werden MUSS!
			voice->Porta.PortaOn=false;
		}
		setPlayerTuning(voice, voice->ActTon=Note);
		if (voice->PortaDoItFine) 
		{
			voice->Porta.EndNote=0; // Wieder lschen, da neugesetzt werden MUSS!
			voice->Porta.PortaOn=false;
		}
	}
	if (voice->Vibrato.VibratoOn)
	{
		signed long NoteAdd;

		switch (voice->Vibrato.Type)
		{
			case 3:																//Random. Just The Sinewave...
			case 0:	NoteAdd=(VibratoTable[voice->Vibrato.ActTablePos])<<4;		//Sinus
					if (voice->Vibrato.Negativ) NoteAdd*=-1;
					break;
			case 1: NoteAdd=voice->Vibrato.ActTablePos<<3;						//Sgezahn (runter)
					if (voice->Vibrato.Negativ) NoteAdd+=248;//31<<3
					NoteAdd<<=4;
					break;
			case 2: NoteAdd=(255<<4);											//Squarewave
					if (voice->Vibrato.Negativ) NoteAdd*=-1;
					break;
		}

		NoteAdd*=voice->Vibrato.Amplitude;
		NoteAdd>>=7;
		unsigned long divisor = (unsigned long)((signed long)(voice->ActTon)+NoteAdd);
		
		setPlayerTuning(voice, divisor);
	
		voice->Vibrato.ActTablePos+=voice->Vibrato.Step;
		if (voice->Vibrato.ActTablePos>=32)
		{
			voice->Vibrato.Negativ=!voice->Vibrato.Negativ;
			voice->Vibrato.ActTablePos-=32;
		}
	}
}	

// Arpeggio
void DoEffekt0(struct voicememory *voice, bool StartEffekt)
{
	if (StartEffekt)
	{
		//int hlp=GetNoteIndex(voice->PatternTon>>4);
		int hlp = voice->PatternNoteIndex+12*voice->PatternNoteOctave;

		if (hlp<0 || hlp>nNotes) // ungltige Note!
		{
			voice->Arp.Note[0]=voice->Arp.Note[1]=voice->Arp.Note[2]=0;
		}
		else
		if (voice->PlayerActSampleData)
		{
			unsigned long SampleBase = voice->PlayerActSampleData->BaseFrequenzy;
			voice->Arp.Note[0]=getFinetunePeriod(voice->PatternTon, SampleBase);								//(BASEFreq*(voice->PatternTon))/SampleBase;
			voice->Arp.Note[1]=getFinetunePeriod((notes[hlp+(voice->TheEffektOp >>4)].NoteVal)<<4, SampleBase);	//(BASEFreq*((notes[hlp+(voice->TheEffektOp>>4)].NoteVal)<<4))/SampleBase;
			voice->Arp.Note[2]=getFinetunePeriod((notes[hlp+(voice->TheEffektOp&0xF)].NoteVal)<<4, SampleBase);	//(BASEFreq*((notes[hlp+(voice->TheEffektOp&0xF)].NoteVal)<<4))/SampleBase;
			voice->Arp.ArpOn=true;
		}
		voice->Arp.Index=0;
	}
	else
	{
		voice->Arp.Index = (voice->Arp.Index+1)%3;
		//if (voice->Arp.Index>=3) voice->Arp.Index=0;
		setPlayerTuning(voice, voice->Arp.Note[voice->Arp.Index]);
	}
}

// Porta Up
void DoEffekt1(struct voicememory *voice, bool StartEffekt)
{
	if (StartEffekt)
	{
		if (voice->TheEffektOp)
			voice->Porta.OldPortaStep=voice->Porta.Step=((signed long)(voice->TheEffektOp)<<4)*(-1);
		else
			voice->Porta.Step=voice->Porta.OldPortaStep;

		voice->Porta.ActNote=voice->ActTon=voice->Porta.StartNote=voice->ActTon;
		/*if (!ThisMod->FileType) 
			voice->Porta.EndNote=(113L<<4); // Mindestens hier stoppen, lt. Effektdef.
		else*/
			voice->Porta.EndNote=0;

		//if (voice->Porta.Step && voice->Porta.EndNote) 
			voice->Porta.PortaOn=true;
	}
	else DoTickEffekts(voice);
}

// Porta Down
void DoEffekt2(struct voicememory *voice, bool StartEffekt)
{
	if (StartEffekt)
	{
		if (voice->TheEffektOp)
			voice->Porta.OldPortaStep=voice->Porta.Step=((signed long)(voice->TheEffektOp)<<4);
		else 
			voice->Porta.Step=voice->Porta.OldPortaStep;
		
		voice->Porta.ActNote=voice->ActTon=voice->Porta.StartNote=voice->ActTon;
		/*if (!ThisMod->FileType)
			voice->Porta.EndNote=(856L<<4); // Mindestens hier stoppen, lt. Effektdef.
		else*/
			voice->Porta.EndNote=0x7FFFFFFFL;
		
		//if (voice->Porta.Step && voice->Porta.EndNote) 
			voice->Porta.PortaOn=true;
	}
	else 
		DoTickEffekts(voice);
}

// Porta To Note
void DoEffekt3(struct voicememory *voice, bool StartEffekt)
{
	if (StartEffekt)
	{
		if (voice->TheEffektOp) 
			voice->Porta.OldPortaNoteStep=voice->Porta.Step=((signed long)(voice->TheEffektOp)<<4);
		else 
			voice->Porta.Step=voice->Porta.OldPortaNoteStep;
		
		if (ActualPlace->Ton)
		{
			voice->Porta.ActNote=voice->Porta.StartNote=voice->ActTon;
			// Mindestens hier stoppen
			if (voice->PlayerActSampleData)
				voice->Porta.EndNote=(BASEFreq * (ActualPlace->Ton<<4)) / voice->PlayerActSampleData->BaseFrequenzy;
			//voice->Porta.EndNote=ActualPlace->Ton; 
		}
		
		if (voice->Porta.EndNote<voice->Porta.StartNote && voice->Porta.Step>0 ||
			voice->Porta.EndNote>voice->Porta.StartNote && voice->Porta.Step<0) voice->Porta.Step*=-1;
		
		if (voice->Porta.Step && voice->Porta.EndNote) voice->Porta.PortaOn=true;
	}
	else DoTickEffekts(voice);
}

// Vibrato
void DoEffekt4(struct voicememory *voice, bool StartEffekt)
{
	if (StartEffekt)
	{
		voice->Vibrato.VibratoOn=true; // Nur aktivieren, wenn auch eine Note da ist. Sonst ist es Einstellung!!!
		if (voice->TheEffektOp>>4) voice->Vibrato.Step=(voice->TheEffektOp>>4);
		if (voice->TheEffektOp&0xF) voice->Vibrato.Amplitude=(voice->TheEffektOp&0xF);
	}
	else DoTickEffekts(voice);
}

// Porta + Volslide
void DoEffekt5(struct voicememory *voice, bool StartEffekt)
{
	if (StartEffekt)
	{
		voice->Porta.Step=voice->Porta.OldPortaNoteStep;
		if (ActualPlace->Ton)
		{
			voice->Porta.ActNote=voice->Porta.StartNote=voice->ActTon;
			if (voice->PlayerActSampleData)
				voice->Porta.EndNote=(BASEFreq * (ActualPlace->Ton<<4)) / voice->PlayerActSampleData->BaseFrequenzy;
			//voice->Porta.EndNote=ActualPlace->Ton; // Mindestens hier stoppen
		}
		
		if (voice->Porta.EndNote<voice->Porta.StartNote && voice->Porta.Step>0 ||
			voice->Porta.EndNote>voice->Porta.StartNote && voice->Porta.Step<0) voice->Porta.Step*=-1;

		if (voice->Porta.Step && voice->Porta.EndNote) voice->Porta.PortaOn=true;

		DoEffektA(voice, StartEffekt);
	}
	else DoTickEffekts(voice);
}

// Vibrato + Volslide
void DoEffekt6(struct voicememory *voice, bool StartEffekt)
{
	if (StartEffekt)
	{
		voice->Vibrato.VibratoOn=true;
		DoEffektA(voice, StartEffekt);
	}
	else DoTickEffekts(voice);
}

// Tremolo
void DoEffekt7(struct voicememory *voice, bool StartEffekt)
{
	if (StartEffekt)
	{
		if (voice->TheEffektOp>>4) voice->Tremolo.Step=(voice->TheEffektOp>>4);
		if (voice->TheEffektOp&0xF) voice->Tremolo.Amplitude=(voice->TheEffektOp&0xF);
		voice->Tremolo.TremoloOn=true;
	}
	else
	{
		signed long VolumeAdd;
		
		switch (voice->Tremolo.Type)
		{
			case 3:															//Random, just sinewave
			case 0:	VolumeAdd=VibratoTable[voice->Tremolo.ActTablePos];		//Sinus
					if (voice->Tremolo.Negativ) VolumeAdd*=-1;
					break;
			case 1: VolumeAdd=voice->Tremolo.ActTablePos<<3;				//Sgezahn (runter)
					if (voice->Tremolo.Negativ) VolumeAdd+=248; //31<<3
					break;
			case 2: VolumeAdd=255;											//Squarewave
					if (voice->Tremolo.Negativ) VolumeAdd*=-1;
					break;
		}
		
		VolumeAdd*=voice->Tremolo.Amplitude;
		VolumeAdd>>=7;
		SetVolume(voice, voice->ActVolume+VolumeAdd);
		
		voice->Tremolo.ActTablePos+=voice->Tremolo.Step;
		if (voice->Tremolo.ActTablePos>=32)
		{
			voice->Tremolo.Negativ=!voice->Tremolo.Negativ;
			voice->Tremolo.ActTablePos-=32;
		}
	}
}

// Set Panning
void DoEffekt8(struct voicememory *voice, bool StartEffekt)
{
	if (StartEffekt)
	{
		if (ThisMod->nChannels>1)
		{
			voice->PanningValueR=(long)(voice->TheEffektOp)<<(LMUTLISHIFT-7);		//(long)(((double)(voice->TheEffektOp)/128.0)*FMULTI);
			voice->PanningValueL=(128L-(long)(voice->TheEffektOp))<<(LMUTLISHIFT-7);	//(long)(((128.0-(double)(voice->TheEffektOp))/128.0)*FMULTI);
			SetVolume(voice, voice->ActVolume);
		}
	}
}

// SampleOffset
void DoEffekt9(struct voicememory *voice, bool StartEffekt)
{
	if (StartEffekt)
	{
		if (ActualPlace->Ton && voice->PlayerActSampleData) 
		{
			unsigned long hlp = (unsigned long)(voice->TheEffektOp)<<8;
			if (hlp<voice->PlayerActSampleData->Length)
				SetSamplePos(voice,hlp);
		}
	}
}

// VolumeSlide
void DoEffektA(struct voicememory *voice, bool StartEffekt)
{
	if (StartEffekt)
	{
		unsigned char EffektOp = voice->TheEffektOp;
		unsigned char EffektOpX = (EffektOp>>4)&0x0F;
		unsigned char EffektOpY = EffektOp&0x0F;
		
		if (ThisMod->FileType==0x10) // S3M
		{
			if (EffektOpY && EffektOpX==0xF)
			{
				voice->VolSlide=EffektOpY*(-1);
				voice->VolumeDoItFine=true;
			}
			else
			if (EffektOpX && EffektOpY==0xF)
			{
				voice->VolSlide=EffektOpX;
				voice->VolumeDoItFine=true;
			}
			else
			if (EffektOpY) // Decrease
				voice->VolSlide=EffektOpY*(-1);
			else
			if (EffektOpX)
				voice->VolSlide=EffektOpX;
		}
		else
		{
			if (EffektOpX)
				voice->VolSlide=EffektOpX;
			else
				voice->VolSlide=EffektOpY*(-1);
		}
		
		voice->VolSlideOn=true;
	}
	else DoTickEffekts(voice);
}

// PosJump
void DoEffektB(struct voicememory *voice, bool StartEffekt)
{
	if (StartEffekt)
	{
		// Einbau eines Abschaltens dieses Effektes bei Playlisten mit folgendem
		// Algorithmus (Verbesserte Version)
		// - Merken von bereits gespielten PatternPos in der Playlist.
		// - Ist ein Pattern bereits gespielt worden, darf nicht gesprungen werden
		// Notwendig, da sonst ein mit wilden Spngen komponiertes Stck inklusive
		// Rckwrtssprngen nicht mehr richtig gespielt wird.
		if (voice->TheEffektOp<=PlayerActPatternIndex && !PlayerLoopsAllowed) return;
		PatternPosJump=true;
		PatternNextPos=voice->TheEffektOp;
	}
}

// Set Volume
void DoEffektC(struct voicememory *voice, bool StartEffekt)
{
	if (StartEffekt) SetVolume(voice, voice->ActVolume=voice->TheEffektOp);
}

// Patternbreak;
void DoEffektD(struct voicememory *voice, bool StartEffekt)
{
	if (StartEffekt)
	{
		PatternBreak=true;
		PatternNextRow=((voice->TheEffektOp>>4)*10)+(voice->TheEffektOp&0x0F);
	}
}

void DoEffektQ(struct voicememory *voice, bool StartEffekt)
{
	if (StartEffekt) 
	{
		voice->RetRetrig=voice->Retrig=(!ThisMod->FileType)?voice->TheEffektOp&0xF:voice->TheEffektOp;
	}
	else
	{
		voice->Retrig--;
		if (!voice->Retrig) 
		{
			voice->Retrig=voice->RetRetrig;
			SetSamplePos(voice,0);
		}
	}
}

// Misc. Effekts:
void DoEffektE(struct voicememory *voice, bool StartEffekt)
{
	switch (voice->TheEffektOp>>4)
	{
		case 0x0:	// SetFilter
					break;
		case 0x1:	// Fine Porta Up
					if (StartEffekt)
					{
						voice->Porta.PortaOn=true;
						if (voice->TheEffektOp)
						{
							voice->Porta.Step=(((signed long)(voice->TheEffektOp&0xF))<<4)*(-1);
							voice->Porta.ActNote=voice->Porta.StartNote=voice->ActTon;
							//voice->Porta.EndNote=(113<<4); // Mindestens hier stoppen, lt. Effektdef.
							voice->Porta.EndNote=0;

						}
						voice->PortaDoItFine=true;
					}
					else DoTickEffekts(voice);
					break;
		case 0x2:	// Fine Porta Down
					if (StartEffekt)
					{
						voice->Porta.PortaOn=true;
						if (voice->TheEffektOp)
						{
							voice->Porta.Step=(((signed long)(voice->TheEffektOp&0xF))<<4);
							voice->Porta.ActNote=voice->Porta.StartNote=voice->ActTon;
							//voice->Porta.EndNote=(856<<4); // Mindestens hier stoppen, lt. Effektdef.
							voice->Porta.EndNote=0x7FFFFFFFL;

						}
						voice->PortaDoItFine=true;
					}
					else DoTickEffekts(voice);
					break;
		case 0x3:	// Glissando
					if (StartEffekt) voice->Glissando=(voice->TheEffektOp&0xF!=0);
					break;
		case 0x4:	// Set Vibrato
					if (StartEffekt) voice->Vibrato.Type=voice->TheEffektOp&0x3;
					break;
		case 0x5:	// Set FineTune
					if (StartEffekt) 
					{
						voice->ActTon = getFinetunePeriod(voice->PatternTon<<4, FineTuneTable[voice->TheEffektOp&0xF]); //(BASEFreq * (voice->PatternTon<<4)) / FineTuneTable[voice->TheEffektOp&0xF];
						setPlayerTuning(voice, voice->ActTon);
					}
					break;
		case 0x6:	// JumpLoop
					if (StartEffekt)
					{
						if (!(voice->TheEffektOp&0xF)) // Set the Point!
						{
							LoopPatternNextPos=PlayerActPatternIndex-1;
							LoopPatternNextRow=PlayerActRow;
							LoopPosSet=true;
							break;
						}
						if (LoopCount==-1) 
						{
							if (!LoopPosSet) 
							{
								LoopPatternNextPos=PlayerActPatternIndex-1;
								LoopPatternNextRow=0;
								LoopPosSet=true;
							}
							LoopCount=voice->TheEffektOp&0xF;
						}
						if (LoopCount>0 && LoopPosSet)
						{
							PatternNextPos=LoopPatternNextPos;
							PatternNextRow=LoopPatternNextRow;
							LoopCount--;
							PatternPosJump=true;
							PatternBreak=true;
							break;
						}
						LoopCount=-1;
						LoopPosSet=false;
					}
					break;
		case 0x7:	// Set Tremolo
					if (StartEffekt) voice->Tremolo.Type=voice->TheEffektOp&0x3;
					break;
		case 0x8:	// Set Fine Panning
					if (StartEffekt)
					{
						if (ThisMod->nChannels>1)
						{
							voice->PanningValueR=((long)(voice->TheEffektOp&0xF)<<LMUTLISHIFT)/15L;			//(long)(((double)(voice->TheEffektOp&0xF)/15.0)*FMULTI);
							voice->PanningValueL=((15L-(long)(voice->TheEffektOp&0xF))<<LMUTLISHIFT)/15L;	//(long)(((15.0-(double)(voice->TheEffektOp&0xF))/15.0)*FMULTI);
							SetVolume(voice, voice->ActVolume);
						}
					}
					break;
		case 0x9:	// Retrig Note
					DoEffektQ(voice, StartEffekt);
					break;
		case 0xA:	// Fine Volume Up
					if (StartEffekt)
					{
						voice->VolSlideOn=true;
						voice->VolumeDoItFine=true;
						voice->VolSlide=voice->TheEffektOp&0xF;
					}
					else DoTickEffekts(voice);
					break;
		case 0xB:	// Fine Volume Down
					if (StartEffekt)
					{
						voice->VolSlideOn=true;
						voice->VolumeDoItFine=true;
						voice->VolSlide=(voice->TheEffektOp&0xF)*(-1);
					}
					else DoTickEffekts(voice);
					break;
		case 0xC:	// Note Cut
					if (StartEffekt) 
					{
						voice->NoteCut=voice->TheEffektOp&0xF;
					}
					else
					{
						voice->NoteCut--;
						if (!voice->NoteCut) SetVolume(voice, voice->ActVolume=0);
					}
					break;
		case 0xD:	// Note Delay
					if (StartEffekt) 
					{
						voice->NoteDelay=voice->TheEffektOp&0xF;
					}
					else
					{
						voice->NoteDelay--;
						if (!voice->NoteDelay)
						{
							if (voice->NoteDelayTon!=0xFF)
							{
								if (voice->NoteDelayInstrument && voice->NoteDelayInstrument!=voice->PlayerActSampleData)
								{
									voice->PlayerActSampleData=voice->NoteDelayInstrument;
									SetSamplePos(voice,0);
								}
								
								if (voice->PlayerActSampleData)
								{
									voice->ActTon = getFinetunePeriod(voice->NoteDelayTon, voice->PlayerActSampleData->BaseFrequenzy); //(BASEFreq * voice->NoteDelayTon) / voice->PlayerActSampleData->BaseFrequenzy;
									setPlayerTuning(voice, voice->ActTon);
									SetSamplePos(voice,0);
								}
								else
								{
									voice->PlayerTuning=0;
								}
								voice->NoteDelayTon=0xFF;
							}
						}
					}
					break;
		case 0xE:	// Pattern Delay
					if (StartEffekt) pDelay=voice->TheEffektOp&0xF;
					break;
		case 0xF:	// Funk It!
					break;
	}
}

// SetSpeed
void DoEffektF(struct voicememory *voice, bool StartEffekt)
{
	if (StartEffekt)
	{
		if (ThisMod->FileType==0x10)
		{
			TempoCount=Tempo=voice->TheEffektOp;
			if (!Tempo) // Full Stop
				PlayerReady=true;
		}
		else
		{
			if (voice->TheEffektOp>31) // BPM
			{
				BPMSpeed=voice->TheEffektOp;
				SamplesPerTick=(25*PlayerFrequ)/(BPMSpeed*10);
			}
			else
			{
				TempoCount=Tempo=voice->TheEffektOp;
				if (!Tempo) // Full Stop
					PlayerReady=true;
			}
		}
	}
}

// S3m Set Tempo
void DoEffekt10(struct voicememory *voice, bool StartEffekt)
{
	if (StartEffekt)
	{
		BPMSpeed=voice->TheEffektOp;
		SamplesPerTick=(25*PlayerFrequ)/(BPMSpeed*10);
	}
}

void DoEffektDummy(struct voicememory *voice, bool StartEffekt)
{
}

void GoNextTick()
{
	unsigned long v;
	struct SampleData *ActSample;
	register struct voicememory *voice;

	if (PlayerRewind)
		PlayerMilliSec-=2500000/BPMSpeed;
	else
		PlayerMilliSec+=2500000/BPMSpeed;
	TempoCount--;
	if (TempoCount)
	{
		register struct voicememory *voice;
		unsigned long v;

		for (v=0; v<ThisMod->nChannels; v++)
		{
			voice=&voiceeffekts[v];
			if (voice->TheEffektByte || voice->TheEffektOp)
				DoEffekts[voice->TheEffektByte](voice, false);
		}
		return;
	}
	TempoCount=Tempo;
	if (pDelay)
	{
		// Fine Volume und Fine Porta reaktivieren, falls ntig!
		for (v=0; v<ThisMod->nChannels; v++)
		{
			voice=&voiceeffekts[v];
			if (voice->VolumeDoItFine=true)		// FineVolume ist aktiv
				voice->VolSlideOn=true;
			else
			if (voice->PortaDoItFine=true)		// FinePorta ist aktiv
				voice->Porta.PortaOn=true;
		}
		pDelay--;
		return;
	}

	if (PlayerRewind)
	{
		if (!PlayerActRow)
		{
			if (PlayerActPatternIndex>1) 
			{
				PlayerActPatternIndex-=2;
				PlayerActRow=ActMaxRows-1;
			}
			else 
			{
				PlayerRewind=false;
				PlayerActRow=PlayerActPatternIndex=0;

			}
			PlayerActPattern=ThisMod->SongArrangement[PlayerActPatternIndex];
			ActualPlace=RowIndex[PlayerActPatternIndex][PlayerActRow];
			PlayerActPatternIndex++;
		}
		else 
		{
			PlayerActRow--;
			ActualPlace=RowIndex[PlayerActPatternIndex-1][PlayerActRow];
		}
	}
	else
	{
		PlayerActRow++;
		if (PlayerActRow>=ActMaxRows || PatternBreak || PatternPosJump)
		{
			if (PatternPosJump) 
			{
				PlayerActPatternIndex=PatternNextPos;
				PatternPosJump=false;
			}
			
			if (PlayerActPatternIndex>=ThisMod->SongLength) 
			{
				PlayerFastForward=false;
				PlayerReady=true;
				return;
			}

			PlayerActPattern=ThisMod->SongArrangement[PlayerActPatternIndex];
			ActualPlace=ThisMod->Pattern[PlayerActPattern];
			
			if (PatternBreak)
			{
				ActualPlace=RowIndex[PlayerActPatternIndex][PlayerActRow=PatternNextRow];
				PatternBreak=false;
			}
			else PlayerActRow=0;

			PlayerActPatternIndex++;
			// Loops nicht ber Pattern!
			//LoopCount==-1;
			//LoopPosSet=false;
		}
	}

	for (v=0; v<ThisMod->nChannels; v++)
	{
		voice=&voiceeffekts[v];
		
		// Effekte Stoppen:
		if (voice->Tremolo.TremoloOn)
		{
			if (!ActualPlace || ActualPlace->TimeIndex!=PlayerActRow || ActualPlace->ChannelIndex!=v || ActualPlace->Effekt!=0x07)
			{
				// Folgt weiterhin Tremolo?
				voice->Tremolo.ActTablePos=0;
				voice->Tremolo.Negativ=0;
				SetVolume(voice, voice->ActVolume);
				voice->Tremolo.TremoloOn=false;
			}
		}
		
		// Bei Vibrato altes Tuning wieder herstellen.
		if (voice->Vibrato.VibratoOn)
		{
			if (!ActualPlace || ActualPlace->TimeIndex!=PlayerActRow || ActualPlace->ChannelIndex!=v || (ActualPlace->Effekt!=0x04 && ActualPlace->Effekt!=0x06))
			{
				// Folgt weiterhin Vibrato?
				voice->Vibrato.ActTablePos=0;
				voice->Vibrato.Negativ=0;
				if (voice->ActTon) 
					setPlayerTuning(voice, voice->ActTon);
				else 
					voice->PlayerTuning=0;
				voice->Vibrato.VibratoOn=false;
			}
		}

		if (voice->Arp.ArpOn)
		{
			setPlayerTuning(voice, voice->Arp.Note[0]);
			voice->Arp.ArpOn=false;
		}
		
		voice->VolumeDoItFine=
		voice->PortaDoItFine=
		voice->VolSlideOn=
		voice->Porta.PortaOn=false;
		voice->RetRetrig=voice->Retrig=0; 

		// Auch Tick-Events stoppen...
		voice->TheEffektOp=voice->TheEffektByte=0;

		if (!ActualPlace) continue;
		if (ActualPlace->TimeIndex!=PlayerActRow || ActualPlace->ChannelIndex!=v) continue;

		// Instrument setzen, wenn eines angegeben:
		if (ActualPlace->SampleIndex) 
		{
			voice->NoteDelayInstrument=&ThisMod->Samples[ActualPlace->SampleIndex-1];
			if (!voice->NoteDelayInstrument->BaseFrequenzy) voice->NoteDelayInstrument=NULL;
			// Knnte ungltige Nummer sein...
			if (voice->NoteDelayInstrument) SetVolume(voice, voice->ActVolume=voice->NoteDelayInstrument->Volume);
		}

		unsigned long ton = ActualPlace->Ton;
		if (ton==NoteCutValue) SetVolume(voice, voice->ActVolume=0);
		else
		{
			voice->TheEffektByte=ActualPlace->Effekt;
			voice->TheEffektOp=ActualPlace->Effektop;

			// Nur wenn Ton
			if (ton)
			{
				voice->PatternTon = (ton<<=4);
				voice->PatternNoteIndex = ActualPlace->noteIndex;
				voice->PatternNoteOctave = ActualPlace->noteOctave;
				// NoteDelay
				if (voice->TheEffektByte==0xE && voice->TheEffektOp>>4==0xD)
					voice->NoteDelayTon=ton;
				else
				{
					ActSample = voice->NoteDelayInstrument;
					if (ActSample && ActSample!=voice->PlayerActSampleData)
					{
						voice->PlayerActSampleData=ActSample;
						SetSamplePos(voice,0);
					}
					
					// Wenn kein Porta to Note, dann Tuning auf aktuellen Ton setzen
					if (voice->TheEffektByte!=0x3 && voice->TheEffektByte!=0x5)
					{
						if (voice->PlayerActSampleData)
						{
							//ton = (BASEFreq * ton) / voice->PlayerActSampleData->BaseFrequenzy;
							setPlayerTuning(voice, voice->ActTon=ton=getFinetunePeriod(ton, voice->PlayerActSampleData->BaseFrequenzy));
							// Falls der Operant von Effekt 9 ungltig ist, darf hier nicht gesetzt worden sein!
							if (voice->TheEffektByte!=0x9) SetSamplePos(voice,0);
						}
						else
						{
							voice->PlayerTuning=0;
						}
					}
				}
			}
			if (ActualPlace->Volume!=-1) SetVolume(voice, voice->ActVolume=ActualPlace->Volume);
			if (voice->TheEffektByte || voice->TheEffektOp) DoEffekts[voice->TheEffektByte](voice, true);
		}
			
		ActualPlace=ActualPlace->Next;
	}
}

//#define ClickFilterMax	((signed long)(32000L))
void _FillBuffer(unsigned char *Mylpv,unsigned long SamplesToWrite)
{
    long            s1, s2, TheSampleL, TheSampleR;
    unsigned long   SamplesWritten, ActSamplePos, v;
	struct SampleData *ActSampleData;
	register struct voicememory *voice;
	unsigned int	Start, End;
	
	SamplesWritten=0;

	Start=GetTickCount();
	while (SamplesWritten<SamplesToWrite)
	{
		TheSampleL=TheSampleR=0;

		for (v=0; v<ThisMod->nChannels; v++)
		{
			voice=&voiceeffekts[v];

			if (voice->SamplePos==(unsigned long)(0xFFFFFFFF) ||
				!voice->PlayerActSampleData ||
				voice->PlayerMute || 
				!voice->ActTon) continue;

			if (!voice->PlayerActSampleData->Sample) continue;

			ActSampleData=voice->PlayerActSampleData;
			ActSamplePos=voice->SamplePos;

			s1=ActSampleData->Sample[ActSamplePos]<<QualityShift; //Bessere Qualitt!!!!
			
			// ISP:
			if (PlayerISP)
			{
				ActSamplePos++;
				if (ActSampleData->RepeatStop && ActSamplePos>ActSampleData->RepeatStop)
				{
					ActSamplePos=ActSampleData->RepeatStart;
				}

				if (ActSamplePos>=ActSampleData->Length) 
					s2=0;
				else
					s2=ActSampleData->Sample[ActSamplePos]<<QualityShift; // Bessere Qualitat!!!
				//s1+=(signed long)((((__int64)(s2-s1))*((__int64)(voice->SampleCount)))/(__int64)(LMULTI));
				s1+=(signed long)((((__int64)(s2-s1))*((__int64)(voice->SampleCount)))>>LMUTLISHIFT);
			}

			// Declick
			if (PlayerClick)
			{
				if (voice->InstrHit)
				{
					if (labs(s1-voice->Olds1)>DeClickBorder)
						while (labs(s1-voice->Olds1)>DeClickBorder) s1=(signed long)(((__int64)(s1)+(__int64)(voice->Olds1))>>1);
					else
						voice->InstrHit=false;
				}
				//else
				//if (s1-voice->Olds1>ClickFilterMax) s1=voice->Olds1+ClickFilterMax;
				//else
				//if (voice->Olds1-s1>ClickFilterMax) s1=voice->Olds1-ClickFilterMax;
				
				voice->Olds1=s1;
			}

			TheSampleL+=VOLUMEDL(voice, s1); //NEW
			TheSampleR+=VOLUMEDR(voice, s1);

			voice->SampleCount += voice->PlayerTuning;
			while (voice->SampleCount>=LMULTI) 
			{
				voice->SampleCount-=LMULTI;
				voice->SamplePos++;
				if (ActSampleData->RepeatStop)
				{
					while (voice->SamplePos>ActSampleData->RepeatStop)
					{
						voice->SamplePos -= ActSampleData->RepeatStop;
						voice->SamplePos += ActSampleData->RepeatStart;
					}
				}
				else
				if (voice->SamplePos>=ActSampleData->Length) 
				{
					voice->SamplePos=(unsigned long)(0xFFFFFFFF);
					break;
				}
			}
		}

		if (PlayerISP) // Fine ISP
		{
			OldSampleL=TheSampleL=(signed long)(((__int64)(TheSampleL)+(__int64)(OldSampleL))>>1);
			OldSampleR=TheSampleR=(signed long)(((__int64)(TheSampleR)+(__int64)(OldSampleR))>>1);
		}

		// WideStrereo Mixing
		if (PlayerWideStereo && PlayerChannels>1)
		{
			WideStereoTabL[WideStereoWriteIndex]=TheSampleL;
			WideStereoTabR[WideStereoWriteIndex++]=TheSampleR;
			if (WideStereoWriteIndex>=MAXWideStereo) WideStereoWriteIndex=0;

			TheSampleR+=(WideStereoTabL[WideStereoReadIndex]>>1);
			TheSampleL+=(WideStereoTabR[WideStereoReadIndex++]>>1);
			if (WideStereoReadIndex>=MAXWideStereo) WideStereoReadIndex=0;
		}


		//Bessere Qualitt !!!!
		TheSampleL>>=QualityShiftBack;
		TheSampleR>>=QualityShiftBack;

		if (PlayerChannels==1)				// MONO
		{
			TheSampleL+=TheSampleR;
			if (PlayerClipping)
			{
				if (TheSampleL>ClippingValuePos) TheSampleL=ClippingValuePos;
				if (TheSampleL<ClippingValueNeg) TheSampleL=ClippingValueNeg;
			}

			StereoTabL[SamplesWritten++]=StereoTabR[SamplesWritten]=(signed short)(TheSampleL>>8);
			
			if (PlayerBitPerSample==8)		// MONO 8-Bit
			{
				*(Mylpv++)=PromoteTo8Bit(TheSampleL>>8);
			}
			else
			if (PlayerBitPerSample==16)		// MONO 16-Bit
			{
				*(Mylpv++)=(unsigned char)((TheSampleL>>8)&0xFF);
				*(Mylpv++)=(unsigned char)((TheSampleL>>16)&0xFF);
			}
			else
			if (PlayerBitPerSample==24)		// MONO 24-Bit
			{
				*(Mylpv++)=(unsigned char)(TheSampleL&0xFF);
				*(Mylpv++)=(unsigned char)((TheSampleL>>8)&0xFF);
				*(Mylpv++)=(unsigned char)((TheSampleL>>16)&0xFF);
			}
		}
		else								// Stereo
		{
			if (PlayerClipping)
			{
				if (TheSampleL>ClippingValuePos)  TheSampleL=ClippingValuePos;
				if (TheSampleL<ClippingValueNeg) TheSampleL=ClippingValueNeg;
				if (TheSampleR>ClippingValuePos)  TheSampleR=ClippingValuePos;
				if (TheSampleR<ClippingValueNeg) TheSampleR=ClippingValueNeg;
			}

			StereoTabL[SamplesWritten]=(signed short)(TheSampleL>>8);
			StereoTabR[SamplesWritten++]=(signed short)(TheSampleR>>8);

			if (PlayerBitPerSample==8)		// Stereo 8-Bit
			{
				*(Mylpv++)=PromoteTo8Bit(TheSampleL>>8);
				*(Mylpv++)=PromoteTo8Bit(TheSampleR>>8);
			}
			else
			if (PlayerBitPerSample==16)		// Stereo 16-Bit
			{
				*(Mylpv++)=(unsigned char)((TheSampleL>>8)&0xFF);
				*(Mylpv++)=(unsigned char)((TheSampleL>>16)&0xFF);
				
				*(Mylpv++)=(unsigned char)((TheSampleR>>8)&0xFF);
				*(Mylpv++)=(unsigned char)((TheSampleR>>16)&0xFF);
			}
			else
			if (PlayerBitPerSample==24)		// Stereo 24-Bit
			{
				*(Mylpv++)=(unsigned char)(TheSampleL&0xFF);
				*(Mylpv++)=(unsigned char)((TheSampleL>>8)&0xFF);
				*(Mylpv++)=(unsigned char)((TheSampleL>>16)&0xFF);
				
				*(Mylpv++)=(unsigned char)(TheSampleR&0xFF);
				*(Mylpv++)=(unsigned char)((TheSampleR>>8)&0xFF);
				*(Mylpv++)=(unsigned char)((TheSampleR>>16)&0xFF);
			}
		}

		if (PlayerRewind || PlayerFastForward) 
			BPMCounter+=16;
		else
			BPMCounter++;
		if (BPMCounter>=SamplesPerTick)
		{
			BPMCounter-=SamplesPerTick;
			if (!PlayerReady) GoNextTick();
			else PlayerDigiReady=true;
		}
	}

	End=GetTickCount();
	PlayerActTicks=End-Start;
}

bool FillBuffer(unsigned long dwPos)
{
    long            lNumToWrite;
    unsigned long   dwStartOfs, dwBytes1, dwBytes2, SamplesToWrite;
    void            *lpvPtr1, *lpvPtr2;

	if (useWaveOut)
	{
		int realPos = (!dwPos)?(NUM_PLAY_NOTIFICATIONS - 1):dwPos-1;
		WAVEHDR *current = &blocks[realPos]; 

		if(current->dwFlags & WHDR_PREPARED) 
			waveOutUnprepareHeader(hWaveOut, current, sizeof(WAVEHDR));

		current->dwFlags=0;
		_FillBuffer((unsigned char *)current->lpData, current->dwBufferLength/BufferFaktor);

		waveOutPrepareHeader(hWaveOut, current, sizeof(WAVEHDR));
        waveOutWrite(hWaveOut, current, sizeof(WAVEHDR));
	}
	else
	{
		if (!dwPos)
			dwStartOfs = rgdsbpn[NUM_PLAY_NOTIFICATIONS - 1].dwOffset;
		else
			dwStartOfs = rgdsbpn[dwPos-1].dwOffset;

		lNumToWrite = (long) rgdsbpn[dwPos].dwOffset - dwStartOfs;
		if (lNumToWrite < 0) lNumToWrite += dsbd.dwBufferBytes;
		//lNumToWrite = dsbd.dwBufferBytes;
		
		IDirectSoundBuffer_Lock(g_pDSBuffer,
								dwStartOfs,       // Offset of lock start
								lNumToWrite,      // Number of bytes to lock
								&lpvPtr1,         // Address of lock start
								&dwBytes1,        // Count of bytes locked
								&lpvPtr2,         // Address of wrap around
								&dwBytes2,        // Count of wrap around bytes
								0);               // Flags
		
		SamplesToWrite=dwBytes1 / BufferFaktor;
		
		_FillBuffer((unsigned char *)lpvPtr1, SamplesToWrite);
		
		IDirectSoundBuffer_Unlock(g_pDSBuffer, lpvPtr1, dwBytes1, lpvPtr2, dwBytes2);
	}    
    return TRUE;
}

void Timer_Play()
{
	unsigned long   dwResult;
	if (PlayerReady && PlayerDigiReady)
	{
		StopPlay();
		return;
	}

	dwResult=RetrieveActualNotifySegment();
	if (dwResult!=ActualSegment)
	{
		FillBuffer(ActualSegment=dwResult);
	}
}

void CALLBACK Event_CallBack(UINT wTimerID, UINT msg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	if (!PlayerDone) Timer_Play();
}

void CALLBACK waveOutProc(HWAVEOUT hWaveOut, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2)
{
    if (uMsg == WOM_DONE)
	{
		if (!PlayerDone)
		{
			ActualSegment++;
			if (ActualSegment>=NUM_PLAY_NOTIFICATIONS) ActualSegment=0;
			FillBuffer(ActualSegment);
		}
	}
}

void StopPlay()
{
	if (TimerSet)
	{
		timeKillEvent(mmTimer_ID);
		//KillTimer(ActhWnd, MY_TIMER_ID);
		TimerSet=false;
	}
	
	PlayerDone = true;

	StopBuffer();
	FreeDirectSound();

	PlayerReady=PlayerDigiReady=true;

	if (RowIndex)
	{
		for (unsigned int pattern=0; pattern<ThisMod->SongLength; pattern++) delete RowIndex[pattern];
		delete [] RowIndex;
		RowIndex=NULL;
	}
	if (StereoTabL)
	{
		delete [] StereoTabL;
		StereoTabL=NULL;
	}
	if (StereoTabR)
	{
		delete [] StereoTabR;
		StereoTabR=NULL;
	}
	if (WideStereoTabL)
	{
		delete [] WideStereoTabL;
		WideStereoTabL=NULL;
	}
	if (WideStereoTabR)
	{
		delete [] WideStereoTabR;
		WideStereoTabR=NULL;
	}
}

void DoFastForward(bool anaus)
{
	PlayerFastForward=anaus;
}

void DoRewind(bool anaus)
{
	PlayerRewind=anaus;
}

void InitPlayer()
{
	unsigned int v, patternindex, row;
	register struct voicememory *voice;
	
	dwStopNextTime = 0xFFFF;
	OldSampleL=OldSampleR=0;

	MaxVolume=StartingVolume;
	ThisMod->GlobalTuning=((unsigned long)(((double)(BASETone)*FMULTI)/((double)(PlayerFrequ)/(double)(BASEFreq))))<<4;
	if (voiceeffekts) delete [] voiceeffekts;
	voiceeffekts = new voicememory[ThisMod->nChannels];
	for (v=0; v<ThisMod->nChannels; v++)
	{
		voice=&voiceeffekts[v];

		memset((void *)voice, 0, sizeof(struct voicememory));

		voice->NoteDelayTon=0xFF; 
		SetVolume(voice, voice->ActVolume=0);
		voice->PanningValueL = ThisMod->panningValuesL[v];
		voice->PanningValueR = ThisMod->panningValuesR[v];
	}

	PlayerActTicks=0;
	
	MAXWideStereo=PlayerFrequ/50L;
	WideStereoWriteIndex=MAXWideStereo-1; 
	WideStereoReadIndex=0;
	
	WideStereoTabL = new signed long [MAXWideStereo];
	WideStereoTabR = new signed long [MAXWideStereo];
	memset((void *)WideStereoTabL, 0, sizeof(signed long)*MAXWideStereo);
	memset((void *)WideStereoTabR, 0, sizeof(signed long)*MAXWideStereo);

	pDelay=0; LoopCount=-1; LoopPosSet=false;
	PlayerFastForward=PlayerRewind=PatternBreak=PatternPosJump=false; 
	PatternNextPos=PatternNextRow=0;
	BPMSpeed=ThisMod->BPMSpeed; 
	Tempo=ThisMod->Tempo; 
	BPMCounter=0;
	SamplesPerTick=(25*PlayerFrequ)/(BPMSpeed*10);
	PlayerMilliSec=0;
	ActualPlace=NULL;
	PlayerActPatternIndex=0;
	PlayerActPattern=0;
	ActMaxRows=64;
	// Nchster Tick gleich eine Note!
	TempoCount=1;
	PlayerActRow=ActMaxRows;

	BufferDataLen=PlayerFrequ*PlayerBufferLenMillisec/NUM_PLAY_NOTIFICATIONS;
	while (BufferDataLen % 1000) BufferDataLen++;
	BufferDataLen/=1000;
	StereoTabL=new signed short[BufferDataLen];
	StereoTabR=new signed short[BufferDataLen];

	RowIndex=(struct PatternData ***)new (struct PatternData (*[ThisMod->SongLength]));
	for (patternindex=0; patternindex<ThisMod->SongLength; patternindex++)
	{
		struct PatternData *ret;
		
		ret=ThisMod->Pattern[ThisMod->SongArrangement[patternindex]];
		RowIndex[patternindex]=(struct PatternData **)new (struct PatternData (*[ActMaxRows]));
		for (row=0; row<ActMaxRows; row++)
		{
			if (ret)
			{
				while (ret->TimeIndex < row)
				{
					if (ret->Next) ret=ret->Next;
					else break;
				}
			}
			RowIndex[patternindex][row]=ret;
		}
	}
	BufferFaktor=(PlayerBitPerSample>>3) * PlayerChannels;
	PlayerDone=PlayerDigiReady=PlayerReady=false;
}

void PlayThePiece(HWND hWnd) 
{
	HRESULT hRes;

	if (!hWnd)
	{
		hWnd = GetForegroundWindow();
		if (!hWnd)
		{
			hWnd = GetDesktopWindow();
		}
	}

	ActhWnd=hWnd;

	if (!ThisMod) return;
	// Zu erst einmal stoppen, falls ntig:
	StopPlay();

	// InitDirectSound mit 44kHz, 16Bit, Stereo, Handle of Application in "hWnd"
	hRes=InitDirectSound(hWnd, PlayerFrequ, PlayerBitPerSample, PlayerChannels, (DWORD_PTR)waveOutProc);
	if (hRes!=S_OK) 
	{
		if (useWaveOut)
			MessageBox(hWnd, "Error: Failed to open wave out device", "Error:", MB_ICONERROR);
		else
			MessageBox(hWnd, "Error: Failed to inititialize DirectSound", "Error:", MB_ICONERROR);
		return;
	}
	// Create the Streaming-Buffer:
	hRes=CreateStreamingBuffer(PlayerFrequ, PlayerBitPerSample, PlayerChannels, false);
	if (hRes!=S_OK) 
	{
		if (useWaveOut)
			MessageBox(hWnd, "Error: Failed to create a streaming buffer (WaveOut)", "Error:", MB_ICONERROR);
		else
			MessageBox(hWnd, "Error: Failed to create a streaming secondary buffer (DirectSound)", "Error:", MB_ICONERROR);
		StopPlay();
		return;
	}

	if (useWaveOut) waveOutPause(hWaveOut);
	InitPlayer();
	for (int i=1; i<NUM_PLAY_NOTIFICATIONS; i++)
		FillBuffer(	ActualSegment=i );
	
	if (!useWaveOut)
	{
		mmTimer_ID=timeSetEvent(1/*PlayerBufferLenMillisec/NUM_PLAY_NOTIFICATIONS*/, 0, Event_CallBack, 0, TIME_PERIODIC);
		//SetTimer(hWnd, MY_TIMER_ID, 1, Timer_CallBack);
		TimerSet=true;
	}
	StartBuffer();
}
