#include "stdafx.h"
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <string.h>
#include "WinModFileTypes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Zu finden in Mod_Loader.cpp
extern int _read16BITof68000(int h, unsigned short *word);
extern int _read32BITof68000(int h, unsigned long *dword);
extern int _readNormName(int h, char *buffer, unsigned long len);
extern char ModExtension[4];

void Set_S3mType(int h, struct TheModFile &ModClass)
{
	char Kennung[5];
	unsigned short version;
	unsigned short type;
	unsigned short OrdNum;
	unsigned short InstrNum;
	unsigned short PatNum;

	lseek(h,0x20,SEEK_SET);
	_read(h, &OrdNum, 2L);
	_read(h, &InstrNum, 2L);
	_read(h, &PatNum, 2L);
	// Flags berspringen!
	lseek(h,0x28L,SEEK_SET);
	_read(h,&version, 2L); // Version
	_read(h,&type, 2L); // Type
	_read(h,&Kennung,4L); Kennung[4]=0;

	// Modtyp erkennen:
	ModClass.nSamples=InstrNum;
	ModClass.SongLength=OrdNum;
	ModClass.nPattern=PatNum;
	ModClass.nChannels=32;
	ModClass.SampleType=(unsigned char)(type&0xFF);
	strcpy(ModClass.ModID, Kennung);
	sprintf(ModClass.TrackerName, "ScreamTracker V%d.%d", (int)((version>>8)&0x0F), (int)(version&0xFF));
}

void translate_s3m(unsigned char *oldEffekt, unsigned char *oldEffektByte)
{
	unsigned char efftrans[] = 
	//     A    B    C    D    E    F    G    H    I    J    K     L     M     N     O     P     Q     R     S     T     U     V     W     X     Y     Z
	{0x00,0x0F,0x0B,0x0D,0x0A,0x02,0x01,0x03,0x04,0x07,0xFF,0x06, 0x05, 0x0C, 0x0A, 0x09, 0x08, 0x11, 0x07, 0x0E, 0x10, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00};
	unsigned char opptrans[] =
	{0x00,0x30,0x50,0x40,0x70,0x00,0x00,0x00,0x80,0x00,0x00,0x06,0xC0,0xD0,0xE0,0xF0};

	if (*oldEffekt==19) // S
	{
		// Untereffekte ndern...
		char eff = (*oldEffektByte)>>4;
		char op = opptrans[eff];
		if (!op)
		{
			*oldEffekt=0;
			*oldEffektByte=0;
		}
		else
		{
			*oldEffekt=0x0E;
			*oldEffektByte=((*oldEffektByte)&0x0F)|op;
		}
	}
	else /* Effekt F, OP = Fx oder Ex */
	if (*oldEffekt==6 /*F*/)
	{
		char secondOp = ((*oldEffektByte)>>4)&0x0F;
		if (secondOp == 0xE || secondOp == 0xF) // Extra fine Portamento Up
		{
			*oldEffekt=0xE;
			char oldOp = (*oldEffektByte)&0x0F;
			*oldEffektByte = 0x10 | oldOp;
		}
		else 
			*oldEffekt=0x01;
	}
	else
	if (*oldEffekt==5 /*E*/)
	{
		char secondOp = ((*oldEffektByte)>>4)&0x0F;
		if (secondOp == 0xE || secondOp == 0xF) // Extra fine Portamento Up
		{
			*oldEffekt=0xE;
			char oldOp = (*oldEffektByte)&0x0F;
			*oldEffektByte = 0x20 | oldOp;
		}
		else 
			*oldEffekt=0x02;
	}
	else
	if (*oldEffekt>=0 && *oldEffekt<=26)
	{
		unsigned char eff = efftrans[*oldEffekt];
		if (!eff) // Bisher nicht umgesetzter Effekt. Daher Operant auf 0!
			*oldEffektByte=0;
		else
		if (eff==0xFF) // Arpeggio maskiert
			eff=0;
		
		*oldEffekt=eff;
	}
	else 
	{
		*oldEffekt=0;
		*oldEffektByte=0;
	}
}

void insert_Pattern_S3m(int h, unsigned int PattNum, struct TheModFile &ModClass, int *remap)
{
	struct PatternData *p,*lauf;
	struct PatternData *root;
	unsigned char packbyte;
	unsigned short len;
	unsigned int row=0;
	unsigned int channel=0;
	unsigned char note, instrument, command, info;
	signed char volume;

	_read(h, &len, 2L); len-=2; // die Lnge zhlt mit!!!
	
	while (len>=0)
	{
		_read(h, &packbyte, 1L); len--;
		if (!packbyte) 
		{
			row++;
			if (row==64) break;
		}
		else
		{
			channel = packbyte&31;
			channel = remap[channel]; // Remapping the Channel, if disabled Channels are used!
			if (packbyte&32) // Note und Instrument
			{
				_read(h, &note, 1L); len--;
				_read(h, &instrument, 1L); len--;
			}
			else
			{
				note=255;
				instrument=0;
			}

			if (packbyte&64)
			{
				_read(h, &volume, 1L); len--;
			}
			else
			{
				volume=-1;
			}

			if (packbyte&128)
			{
				_read(h, &command, 1L); len--;
				_read(h, &info, 1L); len--;
				translate_s3m(&command, &info);
			}
			else
			{
				command=0;
				info=0;
			}

			if (channel==-1) continue; // Ungltiger Channel. Allerdings auch noch eben schnell alles dazu lesen!
			p=new struct PatternData;
			p->Next=p->Prev=NULL;
			p->TimeIndex=row;
			p->ChannelIndex=channel;
			if (note==255)
			{
				p->Ton=0;
			}
			else
			if (note==254)
			{
				p->Ton=NoteCutValue;
			}
			else
			{
				int index = ((note>>4)+2)*12+(note&0xF);
				if (index<nNotes) p->Ton=notes[index].NoteVal;
			}

			int hlp=GetNoteIndex(p->Ton);
			p->noteIndex = hlp%12;
			p->noteOctave = hlp/12;

			p->SampleIndex=instrument;
			p->Volume=volume;
			p->Effekt=command;
			p->Effektop=info;
			
			root=ModClass.Pattern[PattNum];
			if (!root) ModClass.Pattern[PattNum]=p;
			else
			{
				lauf=root;
				while (lauf)
				{
					if (!lauf->Next)
					{
						p->Prev=lauf;
						lauf->Next=p;
						break;
					}
					else
					if ((lauf->TimeIndex==row && lauf->ChannelIndex>channel) || lauf->TimeIndex>row)
					{
						p->Next=lauf;
						p->Prev=lauf->Prev;
						lauf->Prev=p;
						if (ModClass.Pattern[PattNum]==lauf) ModClass.Pattern[PattNum]=p; //root verschieben!
						break;
					}
					lauf=lauf->Next;
				}
			}
		}
	}
}

int Read_S3m(int h, struct TheModFile &ModClass, int *Error, long *ErrorValue)
{
	char ReadNames[40];
	unsigned short ReadWord;
	unsigned char ReadByte;
	unsigned int i, PattNum;

	// Angenommen!
	*Error=LOADERROR_NOERROR;
	lseek(h, 0x1DL, SEEK_SET);
	_read(h, &ReadByte, 1);
	lseek(h, 0L, SEEK_SET);
	if (ReadByte!=0x10)
	{
		*Error=LOADERROR_UNSUPPORTED;
		return(0);
	}
	
	ModClass.FileType=0x10;
	ModClass.usesLinearFrequency = false;	// Standard bei S3M

	// Liest den Songnamen inclusive abschiesendem Null-Byte
	_readNormName(h, ReadNames, 28L); ReadNames[28]=0;
	strcpy(ModClass.SongName,ReadNames);

	// Modtyp feststellen
	Set_S3mType(h, ModClass);

	// GlobalVolume
	_read(h, &ReadByte, 1L);
	ModClass.BaseVolume = ReadByte;
	// PlaybackTempo
	_read(h, &ReadByte, 1L);
	ModClass.Tempo=ReadByte;
	// PlaybackBPM
	_read(h, &ReadByte, 1L);
	ModClass.BPMSpeed=ReadByte;
	//m.v, ignored, fast jedenfalls
	_read(h, &ReadByte, 1L);
	bool stereo;
	if (ReadByte&0x80) stereo=true; else stereo=false;
	//u.c, ignored
	_read(h, &ReadByte, 1L);
	//d.p
	_read(h, &ReadByte, 1L);
	ModClass.DefaultPanning=ReadByte;

	lseek(h, 0x40L, SEEK_SET);
	unsigned int anzCh=0;
	unsigned int chVal[32];
	int remap[32];
	for (i=0; i<32; i++)
	{
		_read(h, &ReadByte, 1L);
		if (ReadByte!=255) // !(ReadByte&0x80) oder (ReadByte<16)... was ist richtig?!
		{
			remap[i]=anzCh;
			chVal[anzCh++]=ReadByte;
		}
		else 
			remap[i]=-1;
	}
	ModClass.nChannels=anzCh;

	// Arrangement
	ModClass.SongArrangement=new unsigned long[ModClass.SongLength];
	for (i=0; i<ModClass.SongLength; i++)
	{
		_read(h, &ReadByte, 1L);
		ModClass.SongArrangement[i]=ReadByte;
	}

	// Samples lesen
	ModClass.Samples=new struct SampleData [ModClass.nSamples];
	for (i=0; i<ModClass.nSamples; i++)
	{
		unsigned long DWord;

		lseek(h,0x60L+ModClass.SongLength+(i*2L),SEEK_SET);
		_read(h, &ReadWord, 2L);
		lseek(h, ReadWord*16L, SEEK_SET);

		_read(h, &ReadByte, 1L);
		ModClass.Samples[i].Type=ReadByte;
		
		// DosFileName
		_readNormName(h, ReadNames, 13L); ReadNames[13]=0;
		strcpy(ModClass.Samples[i].DosFileName, ReadNames);

		// Sampleoffset
		_read(h, &ReadWord, 2L);
		ModClass.Samples[i].MemSeg=ReadWord;

		// Anzahl Sampldaten
		_read(h, &DWord, 4L);
		ModClass.Samples[i].Length=((unsigned long)DWord);

		// RepeatStart
		_read(h, &DWord, 4L);
		ModClass.Samples[i].RepeatStart=(unsigned long)DWord;

		// RepeatStop
		_read(h, &DWord, 4L);
		ModClass.Samples[i].RepeatStop=(unsigned long)DWord;

		// No Loop with these Values!
		if ((ModClass.Samples[i].RepeatStart==ModClass.Samples[i].RepeatStop) || (!ModClass.Samples[i].RepeatStart && ModClass.Samples[i].RepeatStop==2) || ModClass.Samples[i].RepeatStop==0xFFFF)
		{
			ModClass.Samples[i].RepeatStart=0;
			ModClass.Samples[i].RepeatStop=0;
		}
		else
		// Begrenzen auf Samplelnge, falls nicht korrekt. (sicher ist sicher!)
		if (ModClass.Samples[i].RepeatStop>ModClass.Samples[i].Length) 
			ModClass.Samples[i].RepeatStop=ModClass.Samples[i].Length;

		// Lautstrke
		_read(h, &ReadByte, 1L);
		ModClass.Samples[i].Volume=ReadByte;

		// Reserved (Sample Beginning Offset?!)
		_read(h, &ReadWord, 2L);

		// Flags: 1:Loop 2:Stereo 4:16Bit-Sample...
		_read(h, &ReadByte, 1L);
		ModClass.Samples[i].Flags=ReadByte;

		//C4SPD
		_read(h, &DWord, 4L);
		ModClass.Samples[i].BaseFrequenzy=DWord;
		ModClass.Samples[i].BaseTone = getTonToFrequenzy(ModClass.Samples[i].BaseFrequenzy);

		// Reserved
		_read(h, ReadNames, 12L);

		//Samplename
		_readNormName(h, ReadNames, 28L); ReadNames[28]=0;
		strcpy(ModClass.Samples[i].Name, ReadNames);

		_read(h, ReadNames, 4L); // Key
		
		// Restlichen Werte:
		ModClass.Samples[i].FineTune=0;
	}

	// Sampledaten:
	for (i=0; i<ModClass.nSamples; i++)
	{
		unsigned long s, SamLen;
		signed char *TempBuffer;

		SamLen=ModClass.Samples[i].Length;
		if (SamLen)
		{
			ModClass.Samples[i].Sample=new signed short[SamLen];
			if (ModClass.Samples[i].Flags&0x04) // 16-Bit-Sample
			{
				for (s=0; s<SamLen; s++)
				{
					ModClass.Samples[i].Sample[s]=0;
				}
			}
			else // 8Bit!
			{
				TempBuffer=new signed char[SamLen];
				lseek(h, ModClass.Samples[i].MemSeg*16L, SEEK_SET);
				_read(h, TempBuffer, SamLen);
				if (ModClass.SampleType==2) // Unsigned Samples
				{
					for (s=0; s<SamLen; s++)
					{
						ModClass.Samples[i].Sample[s]=PromoteTo16Bit(TempBuffer[s]);
					}
				}
				else
				{
					for (s=0; s<SamLen; s++)
					{
						ModClass.Samples[i].Sample[s]=PromModTo16Bit(TempBuffer[s]);
					}
				}

				delete [] TempBuffer;
			}
		} 
		else 
			ModClass.Samples[i].Sample=NULL;
	}

	// Speicher fr alle Pattern reservieren und dann auf NULL initialisieren
	ModClass.Pattern=(struct PatternData **)new (struct PatternData (*[ModClass.nPattern]));
	for (i=0; i<ModClass.nPattern; i++) ModClass.Pattern[i]=NULL;

	for (PattNum=0; PattNum<ModClass.nPattern; PattNum++)
	{
		lseek(h,0x60L+ModClass.SongLength+(ModClass.nSamples*2L)+(PattNum*2L),SEEK_SET);
		_read(h, &ReadWord, 2L);
		lseek(h, ReadWord*16L, SEEK_SET);
		insert_Pattern_S3m(h, PattNum, ModClass, remap);
	}
	
	ModClass.panningValuesL = new signed long[ModClass.nChannels];
	ModClass.panningValuesR = new signed long[ModClass.nChannels];
	if (ModClass.DefaultPanning==0xFC)
	{
		lseek(h,0x60L+ModClass.SongLength+(ModClass.nSamples*2L)+(ModClass.nPattern*2L),SEEK_SET);
		for (i=0; i<32; i++) // 32 Bytes of default Panning
		{
			_read(h, &ReadByte, 1L);
			signed long value = ReadByte&0x0F; // Upper bits are garbage
			int ch = remap[i];
			if (ch!=-1)
			{
				signed long valRight = (value<<LMUTLISHIFT)/15L;
				signed long valLeft  = ((15L-value)<<LMUTLISHIFT)/15L;
				if (chVal[ch]<=7 || value) // Nur bei 0-Werten findet die Unterscheidung statt!
				{
					ModClass.panningValuesR[ch]=valRight;
					ModClass.panningValuesL[ch]=valLeft;
				}
				else
				{
					ModClass.panningValuesR[ch]=valLeft;
					ModClass.panningValuesL[ch]=valRight;
				}
			}
		}
	}
	else
	if (!stereo)
	{
		for (i=0; i<ModClass.nChannels; i++)
		{
			ModClass.panningValuesL[i]=LMULTI>>1; ModClass.panningValuesR[i]=LMULTI>>1;
		}
	}
	else
	{
		for (i=0; i<ModClass.nChannels; i++)
		{
			if (chVal[i]<=7)
			{
				ModClass.panningValuesL[i]=LMULTI; ModClass.panningValuesR[i]=0;
			}
			else
			{
				ModClass.panningValuesR[i]=LMULTI; ModClass.panningValuesL[i]=0;
			}
		}
	}
	
	ModClass.CIAA=0;

	int realLen = 0;
	for (i=0; i<ModClass.SongLength; i++)
	{
		if (ModClass.SongArrangement[i]<254 && ModClass.SongArrangement[i]<ModClass.nPattern)
			ModClass.SongArrangement[realLen++]=ModClass.SongArrangement[i];
	}
	ModClass.SongLength=realLen;

	return(1); // Success
}
